import { TryAgain } from "@/components/try-again"

import LoadingItem from "@/components/loading-item"
import { useGweets } from "../hooks/use-gweets"
import { InfiniteGweets } from "./infinite-gweets"

export const Thread = ({ gweetId }: { gweetId: string }) => {
    const {
        data: threads,
        isLoading,
        isError,
        fetchPreviousPage,
        hasPreviousPage,
        isFetchingPreviousPage,
        isSuccess,
    } = useGweets({
        queryKey: ["gweets", gweetId, "threads"],
        type: "threads",
        id: gweetId,
    })

    if (isLoading) {
        return <LoadingItem />
    }

    if (isError) {
        return <TryAgain />
    }

    return (
        <InfiniteGweets
            gweets={threads}
            fetchPreviousPage={fetchPreviousPage}
            hasPreviousPage={hasPreviousPage}
            isFetchingPreviousPage={isFetchingPreviousPage}
            isSuccess={isSuccess}
        />
    )
}